# -*- coding: utf-8 -*-
"""
Created on Wed May 24 15:06:59 2023

@author: kerb930
"""
import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
import pickle as pk
import matplotlib.dates as mdates

#-----------------------------------------------------------------------------
# Read in data from recorders
#-----------------------------------------------------------------------------
headers = ['# timestamp', 'distribution_load']
data = pd.read_csv('measured_real_power_substation.csv', skiprows=[0,7], names=headers)

time = data['# timestamp']
distribution_load = data['distribution_load']

time = time.iloc[7:-1]
time = time.str[:-4]
time = pd.to_datetime(time, format = '%Y-%m-%d %H:%M:%S',)
#time = time[:-1]
distribution_load = distribution_load.iloc[7:-1]
distLR = []
distLI = []
for idx in range(len(distribution_load)):
    distLR.append(complex(distribution_load.iloc[idx]).real)
    distLI.append(complex(distribution_load.iloc[idx]).imag)
#distLR = distLR[:-1]


headers2 = ['# timestamp', 'distribution_real_energy']
data2 = pd.read_csv('measured_real_energy_substation.csv', skiprows=[0,7], names=headers2)
time2 = data['# timestamp']
distribution_real_energy = data2['distribution_real_energy']

time2 = time2.iloc[7:-1]
time2 = time2.str[:-4]
time2 = pd.to_datetime(time, format = '%Y-%m-%d %H:%M:%S',)
distribution_real_energy = distribution_real_energy.iloc[7:-1]
distRE = []
for idx in range(len(distribution_real_energy)):
    distRE.append(float(distribution_real_energy.iloc[idx]))
#distRE = distRE[:-1]

headers3 = ['','outprice']
data3 = pd.read_csv('eventprice.csv', names=headers3, dtype='float64', skiprows=1)
allp = data3['outprice'].iloc[0:]
allp = allp.tolist()
ep = data3['outprice'].iloc[24:]
ep = ep.tolist()
eprice = np.repeat(ep,60)
allp = np.repeat(allp,60)
eventprice = []
for idx in range(len(time)): 
    eventprice.append(eprice[idx])

avgprice = []
for idx in range(len(time)):  
    avgprice.append(np.average(np.float_(allp[idx:idx+1440])))


headers4 = ['# property.. timestamp','avg(air_temperature)']
data4 = pd.read_csv('avgairtemp.csv', names=headers4, skiprows=[0,7])
airtemp = data4['avg(air_temperature)']
airtemp = airtemp.iloc[7:-1]
at = []
for idx in range(len(airtemp)):
    at.append(float(airtemp.iloc[idx]))
    
headerso = ['# property.. timestamp','avg(outdoor_temperature)']
datao = pd.read_csv('avgouttemp.csv', names=headerso, skiprows=[0,7])
outtemp = datao['avg(outdoor_temperature)']
outtemp = outtemp.iloc[7:-1]
ot = []
for idx in range(len(outtemp)):
    ot.append(float(outtemp.iloc[idx]))


headers5 = ['# property.. timestamp','avg(cooling_setpoint)']
data5 = pd.read_csv('avgcooling_setpoint.csv', names=headers5, skiprows=[0,7])
cooling_setpoint = data5['avg(cooling_setpoint)']
cooling_setpoint = cooling_setpoint.iloc[7:-1]
coolset = []
for idx in range(len(cooling_setpoint)):
    coolset.append(float(cooling_setpoint.iloc[idx]))
   
datacool = pd.read_csv('AvgCooling_Schedule_edit.csv')
cooldata = []
for idx in range(len(datacool)):
     cooldata.append(float(datacool.iloc[idx]))
cooldata = np.repeat(cooldata,60)
cooldata = cooldata[:len(time)] #cooldata[:2879] #-1

headers6 = ['# property.. timestamp','avg(is_COOL_on)']
data6 = pd.read_csv('avgcoolON.csv', names=headers6, skiprows=[0,7])
is_COOL_on = data6['avg(is_COOL_on)']
is_COOL_on = is_COOL_on.iloc[7:-1]
coolON = []
for idx in range(len(is_COOL_on)):
    coolON.append(float(is_COOL_on.iloc[idx]))

headers7 = ['# property.. timestamp','avg(heating_setpoint)']
data7 = pd.read_csv('avgheating_setpoint.csv', names=headers7, skiprows=[0,7])
heating_setpoint = data7['avg(heating_setpoint)']
heating_setpoint = heating_setpoint.iloc[7:-1]
heatset = []
for idx in range(len(heating_setpoint)):
    heatset.append(float(heating_setpoint.iloc[idx]))

headers8 = ['# property.. timestamp','avg(is_HEAT_on)']
data8 = pd.read_csv('avgheatON.csv', names=headers8, skiprows=[0,7])
is_HEAT_on = data8['avg(is_HEAT_on)']
is_HEAT_on = is_HEAT_on.iloc[7:-1]
heatON = []
for idx in range(len(is_HEAT_on)):
    heatON.append(float(is_HEAT_on.iloc[idx]))

headers9 = ['# property.. timestamp','avg(hvac_load)']
data9 = pd.read_csv('avghvac_load.csv', names=headers9, skiprows=[0,7])
hvac_load = data9['avg(hvac_load)']
hvac_load = hvac_load.iloc[7:-1]
hvac = []
for idx in range(len(hvac_load)):
    hvac.append(float(hvac_load.iloc[idx]))
    
# headersHB = ['# property.. timestamp','avg(hvac_load)']
# dataHB = pd.read_csv('avghvac_load_BASE.csv', names=headers9, skiprows=[0,7])
# hvac_loadB = dataHB['avg(hvac_load)']
# hvac_loadB = hvac_loadB.iloc[7:-1]
# hvacB = []
# for idx in range(len(hvac_loadB)):
#     hvacB.append(float(hvac_loadB.iloc[idx]))

# Pickle HVAC delta for each event price run
# Move file to folder with event price: local_dir + '\\' + r'500\hvac_pickle'
hvacpk = open('hvac_pickle', 'wb')
pk.dump([time, np.array(hvac)], hvacpk)
hvacpk.close()

headers10 = ['# property.. timestamp','avg(measured_real_energy)']
data10 = pd.read_csv('avgmeasured_real_energy.csv', names=headers10, skiprows=[0,7])
avgmeasured_real_energy = data10['avg(measured_real_energy)']
avgmeasured_real_energy = avgmeasured_real_energy.iloc[7:-1]
avgME = []
for idx in range(len(avgmeasured_real_energy)):
    avgME.append(float(avgmeasured_real_energy.iloc[idx]))
    

#-----------------------------------------------------------------------------
# Plot data: Real Energy, HVAC Load, HVAC delta, Cooling Setpoint, 
# Average Air Temp, Real Distribution Energy & Load, VS PRICE
#-----------------------------------------------------------------------------

fig, ax1 = plt.subplots(figsize=(6, 3), dpi=300)
ax1.plot(time, avgME, label='Avg Measured Real Energy', color='red')
ax2 = ax1.twinx()
ax2.plot(time, eventprice, label='Price', color='green')
ax2.set_ylabel('Price ($)', fontsize=11)
ax1.legend(loc='center left', bbox_to_anchor=(1.14,0.2), ncol=1)
ax2.legend(loc='lower left', bbox_to_anchor=(1.14,0.5), ncol=1)
fig.autofmt_xdate(rotation=45)
ax2.xaxis.set_major_formatter(mdates.DateFormatter('%m-%d %H:%M'))
plt.grid(True, color='lightgrey', linestyle=':', zorder=0)
plt.title('Avg Measured Real Energy')
plt.savefig('AvgMeasuredRealEnergy.jpg', bbox_inches = 'tight', dpi=300)

fig, ax1 = plt.subplots(figsize=(6, 3), dpi=300)
ax1.plot(time, hvac, label='HVAC load', color='red')
#ax1.plot(time, np.array(hvacB)-np.array(hvac), label='HVAC Delta', color='cyan')
ax2 = ax1.twinx()
ax2.plot(time, eventprice, label='Price', color='green')
ax2.set_ylabel('Price ($)', fontsize=11)
ax1.legend(loc='center left', bbox_to_anchor=(1.14,0.2), ncol=1)
ax2.legend(loc='lower left', bbox_to_anchor=(1.14,0.5), ncol=1)
fig.autofmt_xdate(rotation=45)
ax2.xaxis.set_major_formatter(mdates.DateFormatter('%m-%d %H:%M'))
plt.grid(True, color='lightgrey', linestyle=':', zorder=0)
plt.title('HVAC Load')
plt.savefig('HVACload.jpg', bbox_inches = 'tight', dpi=300)

# fig, ax1 = plt.subplots(figsize=(6, 3), dpi=300)
# #ax1.plot(time, np.array(hvacB)-np.array(hvac), label='HVAC Delta', color='cyan')
# ax2 = ax1.twinx()
# ax2.plot(time, eventprice, label='Price', color='green')
# ax2.set_ylabel('Price ($)', fontsize=11)
# ax1.legend(loc='center left', bbox_to_anchor=(1.14,0.2), ncol=1)
# ax2.legend(loc='lower left', bbox_to_anchor=(1.14,0.5), ncol=1)
# fig.autofmt_xdate(rotation=45)
# plt.grid(True, color='lightgrey', linestyle=':', zorder=0)
# plt.title('HVAC DELTA')


fig, ax1 = plt.subplots(figsize=(6, 3), dpi=300)
#ax1.plot(time, 70 + np.array(coolON), label='isCool_ON', color='black')
ax1.plot(time, coolset, label='Cooling Setpoint', color='blue')
ax1.plot(time, cooldata, label='Cooling Schedule Setpoint', color='cyan')
ax1.plot(time, at, label='Average Air Temp', color='red')
#ax1.plot(time, ot, label='Outdoor Temp', color='orange')
ax2 = ax1.twinx()
ax2.plot(time, eventprice, label='Price', color='green')
ax2.plot(time, avgprice, label='Average Price', color='green', linestyle='-.')
ax2.set_ylabel('Price ($)', fontsize=11)
ax1.legend(loc='center left', bbox_to_anchor=(1.14,0.2), ncol=1)
ax2.legend(loc='lower left', bbox_to_anchor=(1.14,0.5), ncol=1)
fig.autofmt_xdate(rotation=45)
ax2.xaxis.set_major_formatter(mdates.DateFormatter('%m-%d %H:%M'))
plt.grid(True, color='lightgrey', linestyle=':', zorder=0)
plt.title('House Condition')
plt.savefig('HouseCondition.jpg', bbox_inches = 'tight', dpi=300)

fig, ax1 = plt.subplots(figsize=(6, 3), dpi=300)
ax1.plot(time, distLR, label='Real Distribution Load', color='red')
ax1.set_ylabel('Measured Real Power (kW)', fontsize=11)
ax2 = ax1.twinx()
ax2.plot(time, eventprice, label='Price', color='green')
ax2.set_ylabel('Price ($)', fontsize=11)
ax1.legend(loc='center left', bbox_to_anchor=(1.14,0.2), ncol=1)
ax2.legend(loc='lower left', bbox_to_anchor=(1.14,0.5), ncol=1)
fig.autofmt_xdate(rotation=45)
ax2.xaxis.set_major_formatter(mdates.DateFormatter('%m-%d %H:%M'))
plt.grid(True, color='lightgrey', linestyle=':', zorder=0)
plt.title('Substation Real Power')
plt.savefig('SubstationRealPower.jpg', bbox_inches = 'tight', dpi=300)

fig, ax1 = plt.subplots(figsize=(6, 3), dpi=300)
ax1.plot(time, distRE, label='distribution_real_energy', color='red')
ax1.set_ylabel('Measured Real Energy (kWh)', fontsize=11)
ax2 = ax1.twinx()
ax2.plot(time, eventprice, label='Price', color='green')
ax2.set_ylabel('Price ($)', fontsize=11)
ax1.legend(loc='center left', bbox_to_anchor=(1.14,0.2), ncol=1)
ax2.legend(loc='lower left', bbox_to_anchor=(1.14,0.5), ncol=1)
ax2.xaxis.set_major_formatter(mdates.DateFormatter('%m-%d %H:%M'))
fig.autofmt_xdate(rotation=45)
plt.grid(True, color='lightgrey', linestyle=':', zorder=0)
plt.title('Substation Real Energy')
plt.savefig('SubstationRealEnergy.jpg', bbox_inches = 'tight', dpi=300)

